package model.personne;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

@SuppressWarnings("serial")
@Entity
@Table(name="Personne")
public class PersonneDTO implements Serializable{
	
	@Id   // the primary key of the table
	@GeneratedValue //the default value is AUTO==> the primary key is generated automatically
	@Column(name="Id", nullable=false)  //the name's column is Id and this column will not be null
	private long id;

	@Column(name="Nom" , nullable=false)
	private String nom;//name of person
	
	@Column(name="Prenom" , nullable=false)
	private String prenom;//name of person	

	@Column(name="Sexe" , nullable=false)
	private String sexe;// gender
	
	@Column(name="Age", nullable=false)
	private int age; //age
	
	@Column(name="DateNaissance", nullable=false)
	@Temporal(TemporalType.DATE)
	private Date dateDeNaissance;// date of birth
	
	@Transient // this variable is not persistent because of the Annotation @Transient
	private String actionAConfirmer;// action to confirm
	@Transient
	private Integer action; //action to do
		

	//default constructor 
	public PersonneDTO(){
		
	}
	
	
	//definition of getter and setter
	public String getNom() {
		return nom;
	}
	
	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getSexe() {
		return sexe;
	}


	public void setSexe(String sexe) {
		this.sexe = sexe;
	}


	public Integer getAction() {
		return action;
	}


	public void setAction(Integer action) {
		this.action = action;
	}
	public String getActionAConfirmer() {
		return actionAConfirmer;
	}


	public void setActionAConfirmer(String actionAConfirmer) {
		this.actionAConfirmer = actionAConfirmer;
	}
	public int getAge() {
		return age;
	}


	public void setAge(int age) {
		this.age = age;
	}


	public Date getDateDeNaissance() {
		return dateDeNaissance;
	}


	public void setDateDeNaissance(Date dateDeNaissance) {
		this.dateDeNaissance = dateDeNaissance;
	}
	public long getId() {
		return id;
	}


	public void setId(long id) {
		this.id = id;
	}
	public String getPrenom() {
		return prenom;
	}


	public void setPrenom(String prenom) {
		this.prenom = prenom;
	}


}
