package model.personne.converter;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

public class AgeConverter implements Converter
{
	
/*****************************************************************************************
 *goal : convert the string value in integer, throws an exception if the value is wrong
 *@author kissangou
 *@param faces : the context
 *@param component : the graphical component
 *@param  value : String value of age
 *@return ageEntry : Integer value of age entered
 *****************************************************************************************/
	
public 	Object getAsObject(FacesContext faces, UIComponent component, String value)throws ConverterException
		{ Integer ageEntered;
			try
				{
					
				   ageEntered= new Integer(value);
				  if(ageEntered<0)
				  {
					throw new Exception("un age ne peut tre ngatif"); //error !! : value cannot be negative 
				  }
				
				}
				catch (Exception e) 
				{
					String msgErreur =e.getMessage();
					if(e.getClass()==NumberFormatException.class)
					{ 
						if(value!="")
						msgErreur="votre nombre n'est pas un entier"; //your number is not an integer
						else
							return null;//la valeur AGE est nulle==> l'attribut requiredMessage est utilis s'il est prsent dans le code
						                //the value of Age is null ==> attribute requiredMessage is used if it's present in the implementation 
					}
							
					throw new ConverterException(new FacesMessage(msgErreur));
									
				}
				
				return ageEntered;// retourne la valeur de l'age dans la propriet Age du bean personneTDO
				                //return the value of age in the property age of bean  personneTDO
		}

	
		// the function below is not implemented in our application, la fonction ci-dessous n'est pas implment dans notre application
		public 	String getAsString(FacesContext faces, UIComponent component, Object value)throws ConverterException
		{
			return null;
		}
}
