package model.personne.validator;


import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

public class NameValidator implements Validator{
	
	
/************************************************************************************************************
 *goal : validate the name or first name entered , throws an exception if the value has undesirable character
 *@author kissangou
 *@param faces : the context
 *@param component : the graphical component
 *@param  nameOrFirstname : name or first name entered
 *@return void 
 *************************************************************************************************************/
	public void validate(FacesContext faces, UIComponent component, Object nameOrFirstname)throws ValidatorException 
	{
		String nameOrFirstnameEntered = nameOrFirstname.toString().trim().toUpperCase();
		//recherche de caractre indsirables
		//undesirable character search
		for(int   valueAsciiOfUndesirableChar =33; valueAsciiOfUndesirableChar<=64||
		          valueAsciiOfUndesirableChar>=91&&valueAsciiOfUndesirableChar<=96||
		          valueAsciiOfUndesirableChar>=123&&valueAsciiOfUndesirableChar<=126; 
		          valueAsciiOfUndesirableChar++
		    )
		{
			if (-1 == nameOrFirstnameEntered.indexOf(valueAsciiOfUndesirableChar)) 
			{
				;// ne rien faire car aucun caractere indsirable
				//do nothing, there are no undesirable characters
			}
			else 
			{
				throw new ValidatorException(new FacesMessage("il ya des caracteres indsirables !!"));//there are undesirable characters
			}			
	    }
		
				
	}
	
	
}
