package services;
import org.hibernate.Session;

import java.util.ArrayList;
import java.util.List;
import model.personne.PersonneDTO;
import model.dao.*;

public class Controller {
	
	
	private AbstractFactoryDAO factory;	
	private InterfaceDAO dao;
	private PersonneDTO personne;
	private List<PersonneDTO> listpersonne;	
	private int action_A_Faire;
	private Session sessionCourante;
	
	/**
	 * we advise you to define the default constructor, even if there is nothing
	 * */	
	public Controller()
	{
		this.factory=new RealFactoryDAO();//we initialize the property factory 
		dao=factory.getPersonneDAOObject();//initialization of the property dao
		this.listpersonne= new ArrayList<PersonneDTO>();//default initialization of listpersonne
		sessionCourante=InitHibernate.getSession();//initialization of the session, initialisation de la session
		
												 
	}
	
/** **************************************************************************************************
 *goal :this function is called by  actionAFaire() function to process all actions of our application  
 *@author kissangou julis
 *@param  ss(the current session used)
 *@param action(action to do)
 *@return result of the action : rsultat de l'action
 *****************************************************************************************************/

@SuppressWarnings("unchecked")
 public int executeAction(Session ss,int action){
	 int resultat_action=Action.TERMINE;
	 
	 switch(action)
		{
			                    		
		case Action.ENREGISTRE_DONNEE: 
		//we save the person in the data base
			ss.beginTransaction();//beginning of the transaction
			dao.creerObjet(ss,personne); 
			ss.getTransaction().commit();// end of the transaction
			break;
			
		case Action.VERIFIER_DONNEE:
			 //here we check the presence of the person entered in the database
			listpersonne=(List<PersonneDTO>)dao.lireObjet(ss,"from PersonneDTO where Nom="+"'"
					+personne.getNom()+"'"+"and Prenom="+"'"+personne.getPrenom()+"'");
			break;
			
		case Action.EFFACER_DONNEE: 
			ss.beginTransaction();//beginning of the transaction
			dao.detruireObjet(ss, "delete from PersonneDTO where Nom="+"'"
					+personne.getNom()+"'"+"and Prenom="+"'"+personne.getPrenom()+"'");
			ss.getTransaction().commit();// end of the transaction
			
			break;
		
		case Action.LIRE_LA_BASE_DE_DONNEES: break;
				
		case Action.EFFACER_PLUSIEURS_DONNEES : break;
		default: 
			
							
		}
	 return resultat_action;
	 
 } 	
/**************************************************************************************************
 *goal :this function is used to process all actions of our application and forward to outcome page 
 *@author  kissangou julis
 *@param no parameter as input
 *@return outcome page : page  venir
 *************************************************************************************************/
 
public 	String actionAFaire()
	{
		if(personne.getActionAConfirmer().equals("Confirmer"))
		{		
			    int action=Action.DEBUT;			
				
				action=personne.getAction();
							
				executeAction( sessionCourante,action);
				
				personne.setActionAConfirmer("annuler");//useful for the last web page , to enter in the else of the function actionActionAfaire:
				                                        //utile pour la derniere page web, pour entrer ds le else de la fonction actionActionAfaire
				setAction_A_Faire(personne.getAction());//useful for the actionConfirmee.jsp page: utile pr la page actionConfirmer				
				
			    return "actionConfirmee"; //forward to the page actionConfirme.jsp, redirection vers la pape actionConfirme.jsp
			      							//end of  action , action termine			    
		}
		else
		{	
			return "annuler"; //forward to the page formulaire.jsp : redirection vers la page formulaire.jsp
		}		
		
	}

/**************************************************************************************************
 *goal :this function is used to process the closure of current session 
 *@author  kissangou julis
 *@param no parameter as input
 *@return outcome page : page  venir
 *************************************************************************************************/
public  String getFermerLaSession(){
	sessionCourante.close();//we close the session, end of the unit work: on ferme la session, fin de l'iunit de travail	
	return "annuler";//forward to the page formulaire.jsp
	
}



/*****************************************************************************************
 **********************DEFINITION OF SETTER AND GETTER************************************
 *****************************************************************************************/

	public PersonneDTO getPersonne() {
		return personne;
	}


	public void setPersonne(PersonneDTO personne) {
		this.personne = personne;
	}
	
	public List<PersonneDTO> getListpersonne() {
		return listpersonne;
	}

	public void setListpersonne(List<PersonneDTO> listpersonne) {
		this.listpersonne = listpersonne;
	}
			
	public int getAction_A_Faire() {
		return action_A_Faire;
	}

	public void setAction_A_Faire(int actionAFaire) {
		if((actionAFaire==Action.VERIFIER_DONNEE )&&(listpersonne.size()==Action.DONNEE_INEXISTANTE))
			actionAFaire=Action.DONNEE_INEXISTANTE;
		action_A_Faire = actionAFaire;
	}
	public AbstractFactoryDAO getFactory() {
		return factory;
	}

	public void setFactory(AbstractFactoryDAO factory) {
		this.factory = factory;
	}


}
