package services;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;

public class InitHibernate {
	private static SessionFactory sessionFactory =buildOfSessionFactory();//cette objet cre une seule fois ne peut tre modifi de l'exterieur
	 //elle ne possede pas de setter, on y accede via getSession()



/*****************************************************************************************
*goal : this function is used to instantiate  the only value of sessionFactory
*@author kissangou julis
*@param  no parameter as input
*@return the only value of sessionFactory
*****************************************************************************************/
private static SessionFactory buildOfSessionFactory()//cette methode ne peut tre appeler de l'extrerieur car private
{													//elle n'est appeler qu'une seule fois pour instancier  sessionFactory

		try 
		{
			// Create the SessionFactory from hibernate.cfg.xml
			// CARE! : the AnnotationConfiguration class is useful when you use
			// hibernate with annotation
			return new AnnotationConfiguration().configure("configHibernate/hibernate.cfg.xml").buildSessionFactory();
		} 
		catch (Exception error) 
		{
			System.out.println("ERROR IN HIBERNATE INITIALIZATION!!!" + error);
			throw new ExceptionInInitializerError(error);
		}

	}

	public static Session getSession() {

		return sessionFactory.openSession();
	}

}
